Bug 1317302 - ksh -n does not detect incorrect associative array declaration
ksh -n does not detect incorrect associative array declaration
Status: CLOSED WONTFIX
Product: Red Hat Enterprise Linux 7
Classification: Red Hat
Component: ksh (Show other bugs)
7.2
All Linux
low Severity low
: rc
: ---
Assigned To: Siteshwar Vashisht
BaseOS QE - Apps
:
Depends On:
Blocks: 1298243 1420851
  Show dependency treegraph
 
Reported: 2016-03-13 18:34 EDT by Paul Wayper
Modified: 2017-08-04 12:00 EDT (History)
1 user (show)

See Also:
Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-07-11 10:23:10 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Paul Wayper 2016-03-13 18:34:28 EDT
Description of problem:

ksh has the -n option to do a syntax test of the script and not actually execute it.  This test does not detect and warn on incorrect associative array declaration, whereas execution of the script breaks at that point.

Version-Release number of selected component (if applicable):

93u+ 2012-08-01

How reproducible:

Always

Steps to Reproduce:
1. Create the following scripts:
$ cat ksh_array.ksh 
#!/usr/bin/ksh

typeset -A fn
fn=([foo_key]=foo_val [bar_key]=bar_val)

printf %s\\n ${fn[foo_key]} ${fn[bar_key]}

$ cat ksh_bad_array.ksh 
#!/usr/bin/ksh

typeset -A fn
fn=([foo_key]=foo_val [bar_key])

printf %s\\n ${fn[foo_key]}

$ cat zsh_array.zsh 
#!/usr/bin/zsh

typeset -A fn
fn=(foo_key foo_val bar_key bar_val)

printf %s\\n ${fn[foo_key]} ${fn[bar_key]}

2. Test:
ksh -n ksh_array.ksh && echo result = $?
ksh ksh_array.ksh

3. Test:
ksh -n ksh_bad_array.ksh && echo result = $?
ksh ksh_bad_array.ksh

4. Test:
ksh -n zsh_array.zsh && echo result = $?
ksh zsh_array.zsh

Actual results:

2. Test passes and execution passes:
$ ksh -n ksh_array.ksh && echo result = $?
result = 0
$ ksh ksh_array.ksh
foo_val
bar_val

3. Test passes but execution fails:
$ ksh -n ksh_bad_array.ksh && echo result = $?
result = 0
$ ksh ksh_bad_array.ksh
ksh_bad_array.ksh[4]: [bar_key]: not found [No such file or directory]

4. Test passes but execution fails:
$ ksh -n zsh_array.zsh && echo result = $?
result = 0
$ ksh zsh_array.zsh
zsh_array.zsh: line 4: cannot append index array to associative array fn

Expected results:

2. Test passes and execution passes:
$ ksh -n ksh_array.ksh && echo result = $?
result = 0
$ ksh ksh_array.ksh
foo_val
bar_val

3. Test fails and execution fails:
$ ksh -n ksh_bad_array.ksh && echo result = $?
ksh_bad_array.ksh[4]: [bar_key]: not found [No such file or directory]
result = 1
$ ksh ksh_bad_array.ksh
ksh_bad_array.ksh[4]: [bar_key]: not found [No such file or directory]

4. Test fails and execution fails:
$ ksh -n zsh_array.zsh && echo result = $?
zsh_array.zsh: line 4: cannot append index array to associative array fn
result = 1
$ ksh zsh_array.zsh
zsh_array.zsh: line 4: cannot append index array to associative array fn


Additional info:

As zsh is designed to be mostly identical to ksh in execution but has a different associative array declaration syntax, ksh -n should work as a test of whether we are trying to execute a ksh or zsh shell script.
Comment 3 Siteshwar Vashisht 2017-07-11 10:23:10 EDT
I will move this bug upstream and close it as wontfix in RHEL7.
Comment 4 Siteshwar Vashisht 2017-07-11 13:30:21 EDT
https://github.com/att/ast/issues/55

Note You need to log in before you can comment on or make changes to this bug.